/* XMArrowButton.C */

#include "XMArrowButton.h"
// Super Class : XtPrimitive

/*oodB%XMArrowButton*** Global Declarations and Stuffs ****/
Pixmap XMArrowButton::XMArrowButton_pixmap = XmUNSPECIFIED_PIXMAP; 
res_rec XMArrowButton::_arrowButtonResources[2] = {
  /* name type value default option get set create modified */
  "arrowDirection","UnsignedChar","XmARROW_UP","XmARROW_UP","XmARROW_UP,XmARROW_DOWN,XmARROW_LEFT,XmARROW_RIGHT",
  True,False,False,False,
  "No Help defined",
  "multiClick","UnsignedChar","dynamic","dynamic","XmMULTICLICK_DISCARD,XmMULTICLICK_KEEP",
  True,False,False,False,
  "No Help defined"
};
/*oodE*****************************************************/

XMArrowButton::~XMArrowButton()
{
	// Empty
}

XMArrowButton::XMArrowButton(Widget parent,Arg* al,int ac)
{
  if(ac > 0)
    setXtArgs(al,ac);

  setParent(parent);
  createWidget(arrowbutton_v);

  /* IF no pixmaps has been created */
  if(XMArrowButton_pixmap == XmUNSPECIFIED_PIXMAP)
  { /* create a pixmap */ 
    if ( XpmCreatePixmapFromData ( XtDisplay(getWidget()), 
                                 DefaultRootWindow (XtDisplay(getWidget())),
                                 XMArrowButton_xpm, 
                                 &XMArrowButton_pixmap, NULL, NULL ) != 0 )
       XMArrowButton_pixmap = XmUNSPECIFIED_PIXMAP;
  } /* create a pixmap */

  /* get resources for this widget */
  storeResources();
}

Pixmap XMArrowButton::getPixmap(void)
{
	return XMArrowButton_pixmap;
}

Boolean XMArrowButton::canbeParent(void)
{
  return False;
}

res_rec * XMArrowButton::getResources(void)
{
  return _resources;
}

int XMArrowButton::getNumResources(void)      
{
  return _numResources;
}

void XMArrowButton::storeResources(void)
{ /*  */ 
  res_rec * primitiveResources = XtPrimitive::getResources();
  int primitiveNumResources = XtPrimitive::getNumResources();

  int totalNumResources;

  totalNumResources = _numResources + 
                      primitiveNumResources;

  _resources = (res_rec *)malloc(totalNumResources*sizeof(res_rec));
 
  memmove(_resources,_arrowButtonResources,_numResources*sizeof(res_rec));
  memmove(&_resources[_numResources],
          primitiveResources,primitiveNumResources*sizeof(res_rec));
  _numResources = totalNumResources;
} /*  */ 
